<?php
/*                                                       */
/* copyseasons.php - Copy prices of seasons to new year  */
/* $ID 211c - 2024-01-08 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

require('../../config/config.php');

// Include BC admin wrapper script
$print_info_banner = true;
require(BC_PATH.'/modules/admin.php');

// Check the user has permissions
if(FALSE === $admin->get_permission('calendar_modify','module') OR FALSE === $admin->get_object_permission($object_id)){
  $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES'],$backerror);
}
function getAsDate($iT, $iY, $iDNr){
//	$day_yearstart = mktime(12, 0, 0, 1, 1, $iY);
	$dayofyear = date("z",$iT);
//	$addweek -=52;
//	$addweek = ($addweek < 0?0:$addweek);
	$startday = date("w", $iT);
	$some_days = $startday-$iDNr;
	if($some_days <= 0){ $some_days += 7; }
	$days_to_dest_w = $dayofyear - $some_days;
	$returndate = mktime(12, 0, 0, 1 , $dayofyear, $iY);
	return $returndate;
}
// Get language from calendar
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}
$backobj = (isset($_GET['backobj'])?$admin->get_get('backobj'):'');
$backerror = BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.($backobj!=''?ARGSO.'backobj='.$backobj:'');
$backsuccess = BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.($backobj!=''?ARGSO.'backobj='.$backobj:'');
$errortext = '';
if(isset($_GET['dayofweek']) AND $_GET['dayofweek']=='1'){ $dayofweek = true; }else{ $dayofweek = false; }
if(isset($_GET['sourceyear']) AND $_GET['sourceyear']!=date('Y',time())){ $sourceyear = $admin->get_get('sourceyear'); }else{ $sourceyear = date('Y',time()); }
$sourceyear = ($sourceyear==0?date('Y',time()):$sourceyear);
if(isset($_GET['destinationyear']) AND $_GET['destinationyear']<=$sourceyear){ $destinationyear = date('Y',time())+1; }else{ $destinationyear = $admin->get_get('destinationyear'); }
$destinationyear = ($destinationyear<=$sourceyear?$sourceyear+1:$destinationyear);
if($datapdo->numRows($datapdo->query("SELECT `rpseas_id` FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$object_id' AND `season_year`='$destinationyear'"))>0){
  $admin->print_error($TEXT['ERROR'].': '.str_replace('[YEAR]',$destinationyear,$CALTEXT['ERROR_SEASEXISTS']),$backerror);
}
if($dayofweek == true AND $datapdo->numRows($datapdo->query("SELECT `rpseas_id` FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$object_id' AND `season_year`='0' AND `season_name`!='SEASON_A'"))>0){
  $admin->print_error($TEXT['ERROR'].': '.$CALTEXT['ERROR_DAYOFWEEK'],$backerror);
}
// Check the destination year is a leap year
$new_isleap = date('L',mktime(12,0,0,1,1,$destinationyear));
$old_isleap = date('L',mktime(12,0,0,1,1,$sourceyear));
// Get the season times from destinationyear
$get_seas = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$object_id' AND `season_year`='$sourceyear' ORDER BY `season_start`");
if($datapdo->numRows($get_seas)>0){
  while($seas = $datapdo->fetchRow($get_seas)){
    $startday = $seas['season_start'];
    $start = mktime(12,0,0,1,$startday,$sourceyear);
    $endday = $seas['season_end'];
    $end = mktime(12,0,0,1,$endday,$sourceyear);
    $season_name = $seas['season_name'];
//    $end = $seas['season_end'];
    $p0 = $seas['p0'];
    $p1 = $seas['p1'];
    $p2 = $seas['p2'];
    $p3 = $seas['p3'];
    $p4 = $seas['p4'];
    $vat = $seas['vat'];
    $arrivaldays = $seas['arrivaldays'];
    $min_resdays = $seas['min_resdays'];
    $allow_min = $seas['allow_min'];
    $ytrue = true;
    if($dayofweek == true){
      $newstart = mktime(12,0,0,date('m',$start),date('d',$start),$destinationyear);
      $newdayS = date('w',$newstart);
      $weekS = date('W',$newstart);
      $dayS = date('w',$start);
      $newdatestart = getAsDate($newstart, $destinationyear, $dayS);
      $newend = mktime(12,0,0,date('m',$end),date('d',$end),$destinationyear);
      $newdayE = date('w',$newend);
      $weekE = date('W',$newend);
      $dayE = date('w',$end);
      $newdateend = getAsDate($newend, $destinationyear, $dayE);
      $chkyear = date('Y',$newdatestart);
      if($chkyear != $destinationyear){ $ytrue = false; }
      if($newdatestart > $newdateend){ $newdatestart = $lastdateend+86400; }
      if($startday == 1){ $newdatestart = mktime(12,0,0,1,1,$destinationyear); }
      if($endday >= 365){ $newdateend = mktime(12,0,0,12,31,$destinationyear); }
      $newstart = date('z',$newdatestart)+1;
      $newend = date('z',$newdateend)+1;
    }
    else{
      $newstart = $startday;
      $newend = $endday;
      if($old_isleap == 0 AND $new_isleap == 1 AND $newstart > 59){ $newstart++; }
      elseif($old_isleap == 1 AND $new_isleap == 0 AND $newstart > 59){ $newstart--; }
      if($old_isleap == 0 AND $new_isleap == 1 AND $newend > 59){ $newend++; }
      elseif($old_isleap == 1 AND $new_isleap == 0 AND $newend > 59){ $newend--; }
      $newdatestart = mktime(12,0,0,1,$newstart,$destinationyear);
      $newdateend = mktime(12,0,0,1,$newend,$destinationyear);
    }
    $lastdateend = $newdateend;
    if($ytrue == true){
      if($newend < $newstart){
        $daystartname = convert_day_month_to_str('longdaystr',date('w',$newdatestart)+1).', ';
        $dayendname = convert_day_month_to_str('longdaystr',date('w',$newdateend)+1).', ';
        $dateformS = (preg_match('/l|D/',DATE_FORMAT)?'':$daystartname);
        $dateformE = (preg_match('/l|D/',DATE_FORMAT)?'':$dayendname);
        $errortext .= $TEXT['ERROR'].': '.(str_replace(array('[STARTDATE]','[ENDDATE]'),array($dateformS.convert_date(DATE_FORMAT,$newdatestart),$dateformE.convert_date(DATE_FORMAT,$newdateend)),$CALTEXT['ERROR_SEASON_STARTEND']));
      }
      else{
        $query = "INSERT INTO `".TABLE_PREFIX."res_price_seas`"
		    ." (`object_id`,`section_id`,`season_start`,`season_end`,`season_year`,`season_name`,"
		    ."`p0`,`p1`,`p2`,`p3`,`p4`,`vat`,`arrivaldays`,`min_resdays`,`allow_min`) VALUES"
		    ." ('$object_id','$section_id','$newstart','$newend','$destinationyear','$season_name',"
		    ."'$p0','$p1','$p2','$p3','$p4','$vat','$arrivaldays','$min_resdays','$allow_min')";
      }
      $datapdo->query($query);
    }
  }
}
else{ $errortext = $TEXT['ERRROR'].': '.$TEXT['NONE_FOUND']; }
if($errortext != ''){ $admin->print_error($errortext,$backerror); }
else{ $admin->print_error($TEXT['SUCCESS'],$backsuccess,0.5); }
$admin->print_footer();
?>