<?php
/*                                                       */
/* save_prices.php - Save prices for calendar object     */
/* $ID 212 - 2023-06-07 - brom $                         */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

require('../../config/config.php');
// Include BC admin wrapper script
$update_when_modified = true; // Tells script to update when this page was last updated
require(BC_PATH.'/modules/admin.php');

// Check the user has permissions
if(FALSE === $admin->get_permission('calendar_modify','module') OR FALSE === $admin->get_object_permission($object_id)){
  $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']);
}
if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
  // no module language file exists for the language set by the user, include default module language file EN.php
  require(BC_PATH .'/modules/calendar/languages/EN.php');
}
else {
  // a module language file exists for the language defined by the user, load it
  require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
}
if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
  require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
}
require_once(BC_PATH.'/modules/calendar/calc_functions.php');
// If the section is not get correctly get it from section table
if($section_id==0){
  $get_calsection = $datapdo->query("SELECT `section_id` FROM `".TABLE_PREFIX."sections` WHERE `object_id`='$object_id' AND `module`='calendar' LIMIT 0,1");
  if($datapdo->numRows($get_calsection)>0){
    $calsection = $datapdo->fetchRow($get_calsection);
    $section_id = $calsection['section_id'];
  }
  if($datapdo->is_error()){
    $admin->print_error($TEXT['ERROR'].': '.$datapdo->get_error());
  }
}
// Add the field addsdate if not exists
$newfield = 0;
$newfield2 = 0;
$newfield3 = 0;
$newfield4 = 0;
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_adds`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='addsstart'){ $newfield = 1; }
  if($row[0]=='addsend'){ $newfield2 = 1; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_adds`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield3 = 1; }
}
$get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."res_price_more`");
while($row = $datapdo->fetchRow($get_fields)){
  if($row[0]=='isold'){ $newfield4 = 1; }
}
if($newfield == 0){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `addsstart` INT(11) NOT NULL");
}
if($newfield2 == 0){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `addsend` INT(11) NOT NULL");
}
if($newfield3 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_adds` ADD `isold` TINYINT(1) NOT NULL");
}
if($newfield4 == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."res_price_more` ADD `isold` TINYINT(1) NOT NULL");
}

// If we can not get the section id correctly get error
if($section_id==0){
  $admin->print_error($TEXT['ERROR'].' '.$TEXT['SECTION'].': '.$MESSAGE['OBJECTS']['NOT_FOUND']);
}

$must_disable_specials = false;
$num_points = array(',','.');
$repl_points = '';
// Get default and all langauges this object
$def_lang = $datapdo->get_one("SELECT `default_language` FROM `".TABLE_PREFIX."objects` WHERE `object_id`='$object_id' LIMIT 1");
$all_lang_array = array($def_lang);
$get_all_lang = $datapdo->query("SELECT `language` FROM `".TABLE_PREFIX."languages` WHERE `object_id`='$object_id' AND `language`!='$def_lang'");
if($datapdo->numRows($get_all_lang)>0){
  while($all_lang = $datapdo->fetchRow($get_all_lang)){
    array_push($all_lang_array,$all_lang['language']);
  }
}
$backobj = '';
$backobjjs = '';

// print_r($_POST);

if(isset($_POST['backobj']) AND is_numeric($_POST['backobj'])){ $backobj = ARGSO.'backobj=1'; $backobjjs = ARGSOJS.'backobj=1'; }
$init_year = 2011; // The year must be not a leap-year
$alldays_year = 365; // The year must be not a leap-year
$error_message = '';
$is_error = false;
$last_seas_id = 0;
$last_holi_id = 0;
$last_adds_id = 0;
$error_adds = '';
// The default arrivaldays like calendar settings, need it if all days are disabled
$arrivaldays = $datapdo->get_one("SELECT `arrivaldays` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$section_id' LIMIT 1");
// Update all settings like price calculator form
$show_prices = $admin->get_post_escaped('show_prices');
$price_type = $admin->get_post_escaped('price_type');
$price_seas = $admin->get_post_escaped('price_seas');
$seas_modus = $admin->get_post_escaped('seas_modus');
$staggering = $admin->get_post_escaped('staggering');
$p_stagg1 = $admin->get_post('p_stagg1');
$p_stagg2 = $admin->get_post('p_stagg2');
$p_stagg3 = $admin->get_post('p_stagg3');
$p_stagg4 = $admin->get_post('p_stagg4');
$p_unit = $admin->get_post('p_unit');
$roundprice = $admin->get_post_escaped('roundprice');
$def_vat = $admin->get_post('def_vat');
$price_export = (isset($_POST['price_export'])?$admin->get_post('price_export'):NULL);
$is_export = ($price_export == NULL?false:true);
$pretype =  $admin->get_post_escaped('pre_type');
if(isset($_POST['preprice']) AND is_numeric($_POST['preprice'])){
  $pretemp = $admin->get_post('preprice');
  $prepricetmp = str_replace($num_points,$repl_points,$pretemp);
  $preprice = intval($prepricetmp);
  //  $preprice = $preprice / 100;
  if($pretype != 1 AND ($preprice / 100)<1){
    $preprice = $preprice / 100;
  }
}
else{
  $preprice = 0;
}
// First update the settings
$query = "UPDATE `".TABLE_PREFIX."res_price_sets` SET "
		      ."`price_type`='$price_type', "
		      ."`price_seas`='$price_seas', "
		      ."`seas_modus`='$seas_modus', "
		      ."`staggering`='$staggering', "
		      ."`p_stagg1`='$p_stagg1', "
		      ."`p_stagg2`='$p_stagg2', "
		      ."`p_stagg3`='$p_stagg3', "
		      ."`p_stagg4`='$p_stagg4', "
		      ."`p_unit`='$p_unit', "
		      ."`preprice`='$preprice', "
		      ."`pretype`='$pretype', "
		      ."`roundprice`='$roundprice', "
		      ."`show_prices`='$show_prices' "
		      ."WHERE `section_id`='$section_id' LIMIT 1";
$datapdo->query($query);
// Next update the table for discounts
$get_discounts = $datapdo->query("SELECT `discount_id`,`lastminute_days`,`discount_type` FROM `".TABLE_PREFIX."res_discounts` WHERE `section_id`='$section_id'");
while($discounts = $datapdo->fetchRow($get_discounts)){
  $did = $discounts['discount_id'];
  $dtype = $discounts['discount_type'];
  $percent = $admin->get_post('percent_'.$did);
  if($percent > 100){ $percent = 100; }
  if(isset($_POST['lastminute_days_'.$did]) AND $_POST['lastminute_days_'.$did] > 0){
    $lastminute_days = $admin->get_post('lastminute_days_'.$did);
  }
  else{ $lastminute_days = $discounts['lastminute_days']; }
  $query = "UPDATE `".TABLE_PREFIX."res_discounts` SET `percent`='$percent',`lastminute_days`='$lastminute_days' WHERE `discount_id`='$did' LIMIT 1";
  $datapdo->query($query);
}
// Now check first we have prices to added
if(isset($_POST['p0_0']) AND $_POST['p0_0'] != '' AND $_POST['p0_0'] != '0'){
  $ptemp = $admin->get_post('p0_0');
  $p0 = str_replace($num_points,$repl_points,$ptemp);
  $p0 = $p0 / 100;
  $ptemp = $admin->get_post('p1_0');
  $p1 = str_replace($num_points,$repl_points,$ptemp);
  $p1 = $p1 / 100;
  $p1 = ($p1 == 0?$p0:$p1);
  $ptemp = $admin->get_post('p2_0');
  $p2 = str_replace($num_points,$repl_points,$ptemp);
  $p2 = $p2 / 100;
  $p2 = ($p2 == 0?$p1:$p2);
  $ptemp = $admin->get_post('p3_0');
  $p3 = str_replace($num_points,$repl_points,$ptemp);
  $p3 = $p3 / 100;
  $p3 = ($p3 == 0?$p2:$p3);
  $ptemp = $admin->get_post('p4_0');
  $p4 = str_replace($num_points,$repl_points,$ptemp);
  $p4 = $p4 / 100;
  $p4 = ($p4 == 0?$p3:$p4);
  $season_name = $admin->get_post('season_name_0');
  $sstart_day = $admin->get_post('sstart_day_0');
  $sstart_month = $admin->get_post('sstart_month_0');
  $send_day = $admin->get_post('send_day_0');
  $send_month = $admin->get_post('send_month_0');
  $season_year = $admin->get_post_escaped('season_year_0');
  if($season_year > 0 AND gmdate('L',mktime(12,0,0,1,1,$season_year))==1){
    $alldays_year=366;
    $init_year = $season_year;
  }
  $season_start = gmdate('z',mktime(12,0,0,$sstart_month,$sstart_day,$init_year))+1;
  $season_end = gmdate('z',mktime(12,0,0,$send_month,$send_day,$init_year))+1;
  if($season_year > 0){ $sql_year = " AND (`season_year`='0' OR `season_year`='".$season_year."')"; }else{ $sql_year = ''; }
  if($season_start>$alldays_year){ $season_start=$alldays_year; }
  if($season_end>$alldays_year){ $season_end=$alldays_year; }
  //Get the season name befor
  $beforestart = $season_start - 1;
  $query_beforename = "SELECT `season_name` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_end`='$beforestart' AND `season_name`='$season_name'".$sql_year." LIMIT 0,1";
  $get_beforename = $datapdo->query($query_beforename);
  if($datapdo->numRows($get_beforename) > 0){
    $season_name .= substr($season_name,-1);
    //Check again for new name
    $query_beforename = "SELECT `season_name` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_end`='$beforestart' AND `season_name`='$season_name'".$sql_year." LIMIT 0,1";
    $get_beforename = $datapdo->query($query_beforename);
    if($datapdo->numRows($get_beforename) > 0){
      $season_name .= substr($season_name,-1);
    }
  }
  if($season_start > $season_end){
    $is_error = true;
    $error_message .= $CALTEXT['SEASON_STARTEND_ERROR'];
  }
  else{
    if(isset($_POST['arrivaldays_0'])){
      $get_arrival = $admin->get_post('arrivaldays_0');
      $arrivaldays = implode(',',$get_arrival);
    }
    $min_resdays = $admin->get_post_escaped('min_resdays_0');
    $allow_min_array = (isset($_POST['allow_min_0'])?$admin->get_post_escaped('allow_min_0'):array());
    if(count($allow_min_array)>0){
      foreach($allow_min_array AS $amK => $amV){
        $allow_min = $amV;
      }
    }
    else{ $allow_min = 0; }
    if($p0 > 0){ // INSERT only if we have a price for new season
      // Check first the new season time are in other
      $sql_year = ($season_year > 0?" AND `season_year`='".$season_year."'":'');
      $get_old_seas = $datapdo->query("SELECT `rpseas_id` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id'".$sql_year." AND ((`season_start`<='$season_start' AND `season_end`>='$season_start') OR (`season_start`<='$season_end' AND `season_end`>='$season_end')) LIMIT 0,1");
      if($datapdo->numRows($get_old_seas)>0){
        $admin->print_error($CALTEXT['SEASON_ADD_ERROR'], BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.$backobj);
      }
      else{
        $query = "INSERT INTO `".TABLE_PREFIX."res_price_seas` "
		 ."(`object_id`,`section_id`,`season_start`,`season_end`,`season_year`,`season_name`,`arrivaldays`,`min_resdays`,`allow_min`,`p0`,`p1`,`p2`,`p3`,`p4`,`vat`) VALUES "
		 ."('$object_id','$section_id','$season_start','$season_end','$season_year','$season_name','$arrivaldays','$min_resdays','$allow_min','$p0','$p1','$p2','$p3','$p4','$def_vat')";
        $datapdo->query($query);
        $last_seas_id = $datapdo->get_one("SELECT LAST_INSERT_ID()");
      }
    }
  }
}
$oldupdate = array();
// Now get all seasons and update them
$get_old_seasons = $datapdo->query("SELECT `rpseas_id`,`p0` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `rpseas_id`!='$last_seas_id'");
if($datapdo->numRows($get_old_seasons)>0){
  while($old_seas = $datapdo->fetchRow($get_old_seasons)){
    $alldays_year= 365;
    $init_year = 2011;
    $rpsid = $old_seas['rpseas_id'];
    $ptemp = $admin->get_post('p0_'.$rpsid);
    $p0tmp = str_replace($num_points,$repl_points,$ptemp);
    $p0 = intval($p0tmp);
    $p0 = $p0 / 100;
    $p0 = ($p0 == 0?$old_seas['p0']:$p0);
    $ptemp = $admin->get_post('p1_'.$rpsid);
    $p1tmp = str_replace($num_points,$repl_points,$ptemp);
    $p1 = intval($p1tmp);
    $p1 = $p1 / 100;
    $p1 = ($p1 == 0?$p0:$p1);
    $ptemp = $admin->get_post('p2_'.$rpsid);
    $p2tmp = str_replace($num_points,$repl_points,$ptemp);
    $p2 = intval($p2tmp);
    $p2 = $p2 / 100;
    $p2 = ($p2 == 0?$p1:$p2);
    $ptemp = $admin->get_post('p3_'.$rpsid);
    $p3tmp = str_replace($num_points,$repl_points,$ptemp);
    $p3 = intval($p3tmp);
    $p3 = $p3 / 100;
    $p3 = ($p3 == 0?$p2:$p3);
    $ptemp = $admin->get_post('p4_'.$rpsid);
    $p4tmp = str_replace($num_points,$repl_points,$ptemp);
    $p4 = intval($p4tmp);
    $p4 = $p4 / 100;
    $p4 = ($p4 == 0?$p3:$p4);
    if(!isset($_POST['sstart_day_'.$rpsid])){
      $season_start = 0;
      $season_end = 0;
      $season_year = 0;
    }
    else{
      $sstart_day = $admin->get_post('sstart_day_'.$rpsid);
      $sstart_month = $admin->get_post('sstart_month_'.$rpsid);
      $send_day = $admin->get_post('send_day_'.$rpsid);
      $send_month = $admin->get_post('send_month_'.$rpsid);
      $season_year = $admin->get_post_escaped('season_year_'.$rpsid);
      if($season_year > 0 AND gmdate('L',mktime(12,0,0,1,1,$season_year))==1){
        $alldays_year=366;
        $init_year = $season_year;
      }
      $season_start = gmdate('z',mktime(12,0,0,$sstart_month,$sstart_day,$init_year))+1;
      $season_end = gmdate('z',mktime(12,0,0,$send_month,$send_day,$init_year))+1;
    }
    $sql_year = " AND `season_year`='".$season_year."'";
    if($season_start>$alldays_year)$season_start=$alldays_year;
    if($season_end>$alldays_year)$season_end=$alldays_year;
    if(!isset($_POST['season_name_'.$rpsid])){ $season_name = 'SEASON_A'; }
    else{ $season_name = $admin->get_post('season_name_'.$rpsid); }
    //Get the season name befor
    if($season_name != 'SEASON_A'){
      $beforestart = $season_start - 1;
      $query_beforename = "SELECT `season_name` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_end`='$beforestart' AND `season_name`='$season_name'".$sql_year." LIMIT 0,1";
      $get_beforename = $datapdo->query($query_beforename);
      if($datapdo->numRows($get_beforename) > 0){
        $season_name .= substr($season_name,-1);
        //Check again for new name
        $query_beforename = "SELECT `season_name` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_end`='$beforestart' AND `season_name`='$season_name'".$sql_year." LIMIT 0,1";
        $get_beforename = $datapdo->query($query_beforename);
        if($datapdo->numRows($get_beforename) > 0){
          $season_name .= substr($season_name,-1);
        }
      }
    }
    if($season_start > $season_end AND strpos($error_message,$CALTEXT['SEASON_TIME_ERROR'])==false){
      $season_start = $season_end;
      $is_error = true;
      $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_TIME_ERROR'];
    }
    if(isset($_POST['arrivaldays_'.$rpsid])){
      $get_arrival = $admin->get_post('arrivaldays_'.$rpsid);
      $arrivaldays = implode(',',$get_arrival);
    }
    $min_resdays = $admin->get_post_escaped('min_resdays_'.$rpsid);
    $allow_min_array = (isset($_POST['allow_min_'.$rpsid])?$admin->get_post_escaped('allow_min_'.$rpsid):array());
    if(count($allow_min_array)>0){
      foreach($allow_min_array AS $amK => $amV){
        $allow_min = $amV;
      }
    }
    else{ $allow_min = 0; }
    // Before update this get old start, end and year for backup
    $get_forback = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_seas` WHERE `rpseas_id`='$rpsid' LIMIT 1");
    $forback = $datapdo->fetchRow($get_forback);
    $oldupdate[] = "UPDATE `".TABLE_PREFIX."res_price_seas` SET "
		   ."`season_start`='".$forback['season_start']."', "
		   ."`season_end`='".$forback['season_end']."', "
		   ."`season_year`='".$forback['season_year']."' "
		   ." WHERE `rpseas_id`='$rpsid' LIMIT 1";

    $query = "UPDATE `".TABLE_PREFIX."res_price_seas` SET "
		   ."`season_start`='$season_start', "
		   ."`season_end`='$season_end', "
		   ."`season_year`='$season_year', "
		   ."`season_name`='$season_name', "
		   ."`arrivaldays`='$arrivaldays', "
		   ."`min_resdays`='$min_resdays', "
		   ."`allow_min`='$allow_min', "
		   ."`p0`='$p0', "
		   ."`p1`='$p1', "
		   ."`p2`='$p2', "
		   ."`p3`='$p3', "
		   ."`p4`='$p4', "
		   ."`vat`='$def_vat' "
		   ." WHERE `rpseas_id`='$rpsid' LIMIT 1";
    $datapdo->query($query);
    if($datapdo->is_error()) {
      $is_error = true;
      $error_message .= (!empty($error_message)?'<br />':'').$datapdo->get_error();
    }
  }
}
if(count($oldupdate)>0){ $_SESSION['oldquery'] = $oldupdate; }
// Check all seasons to overlap
$curryear = date('Y',time());
$nextyear = $curryear+1;
$lastyear = $curryear+2;
$years_array = array(0,$curryear,$nextyear,$lastyear);
$secondcheck = array();
$uquery = array();
foreach($years_array AS $yk => $y){
  $old_end = 0;
  $get_all_seasons = $datapdo->query("SELECT `rpseas_id`,`season_start`,`season_end`,`season_year` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_start`>'0' AND `season_end`>'0' AND `season_year`='$y' ORDER BY `season_year` ASC,`season_start` ASC");
  if($datapdo->numRows($get_all_seasons)>0){
    while($all_seas = $datapdo->fetchRow($get_all_seasons)){
      $alldays_year= 365;
      $this_id = $all_seas['rpseas_id'];
      $this_start = $all_seas['season_start'];
      $this_end = $all_seas['season_end'];
      $this_year = ($y==0?$curryear:$all_seas['season_year']);
      $printoldstart = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_start,$this_year));
      if($this_year > 0 AND gmdate('L',mktime(12,0,0,1,1,$this_year))==1){
        $alldays_year=366;
      }
      if($this_start>$alldays_year OR $this_end>$alldays_year){
        if($this_start>$alldays_year){ $this_start=$alldays_year; }
        if($this_end>$alldays_year){ $this_end=$alldays_year; }
        if(!isset($uquery[$this_id])){
          $uquery[$this_id]="UPDATE `".TABLE_PREFIX."res_price_seas` SET `season_start`='$this_start', `season_end`='$this_end' WHERE `rpseas_id`='$this_id' LIMIT 1";
          if(strpos($error_message,$CALTEXT['SEASON_TIME_ERROR'])==false){
            $is_error = true;
            $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_TIME_ERROR'].' '.$printoldstart.' -> '.$printnewstart;
          }
        }
//        $datapdo->query($uquery);
      }
      if($all_seas['season_year']==0){ $secondcheck[] = array('start'=>$this_start,'end'=>$this_end); };
      if($this_start <= $old_end){
        $this_start = $old_end+1;
        $printnewstart = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_start,$this_year));
        if($this_end<$this_start){ $this_end = $this_start; }
        if(!isset($uquery[$this_id])){
          $uquery[$this_id]="UPDATE `".TABLE_PREFIX."res_price_seas` SET `season_start`='$this_start', `season_end`='$this_end' WHERE `rpseas_id`='$this_id' LIMIT 1";
          if(strpos($error_message,$CALTEXT['SEASON_TIME_ERROR'])==false){
            $is_error = true;
            $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_TIME_ERROR'].' '.$printoldstart.' -> '.$printnewstart;
          }
        }
//        $datapdo->query($uquery);
      }
      $old_end = $this_end;
    }
  }
}
foreach($secondcheck AS $k => $a){
  $start_0 = $a['start'];
  $end_0 = $a['end'];
  $get_s_oy = $datapdo->query("SELECT `rpseas_id`,`season_start`,`season_end`,`season_year` FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id' AND `season_year`>'0' AND (`season_start`>='$start_0' OR `season_end`<='$end_0') ORDER BY `season_year` ASC,`season_start` ASC");
  if($datapdo->numRows($get_s_oy)>0){
    while($s_oy = $datapdo->fetchRow($get_s_oy,false)){
      $this_id = $s_oy['rpseas_id'];
      $this_start = $s_oy['season_start'];
      $this_end = $s_oy['season_end'];
      $this_year = $s_oy['season_year'];
      $printoldstart = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_start,$this_year));
      $printoldend = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_end,$this_year));
      $printnewstart = '';
      $printnewend = '';
      if(gmdate('L',mktime(12,0,0,1,1,$this_year))==1 AND $start_0>59){ $start_0 = $a['start']+1; }
      if(gmdate('L',mktime(12,0,0,1,1,$this_year))==1 AND $end_0>59){ $end_0 = $a['end']+1; }
      else{
        $start_0 = $a['start'];
        $end_0 = $a['end'];
      }
      if($this_start >= $start_0 AND $this_end <= $end_0 AND !isset($uquery[$this_id])){    // we have termins in all years time
        $uquery[$this_id]="DELETE FROM `".TABLE_PREFIX."res_price_seas` WHERE `rpseas_id`='$this_id' LIMIT 1";
//        $datapdo->query($uquery);
        $is_error = true;
        $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_TIME_ERROR'];
      }
      elseif($this_start >= $start_0 AND $this_start <= $end_0){
        $is_error = true;
        $this_start = $end_0+1;
        if($this_end<$this_start){ $this_end = $this_start; }
      }
      elseif($this_end <= $end_0 AND $this_end >= $start_0){
        $is_error = true;
        $this_end = $start_0-1;
        if($this_end<$this_start){ $this_end = $this_start; }
      }
      if(!isset($uquery[$this_id])){
        $uquery[$this_id]="UPDATE `".TABLE_PREFIX."res_price_seas` SET `season_start`='$this_start', `season_end`='$this_end' WHERE `rpseas_id`='$this_id' LIMIT 1";
//      $datapdo->query($uquery);
        if($is_error == true AND strpos($error_message,$CALTEXT['SEASON_TIME_ERROR'])==false){
          $printnewstart = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_start,$this_year));
          $printnewend = convert_date(DATE_FORMAT,mktime(12,0,0,1,$this_end,$this_year));
          $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_TIME_ERROR'].' '.$printoldstart.' - '.$printoldend.' -> '.$printnewstart.' - '.$printnewend;
        }
      }
    }
  }
}
// Now check we have holiday prices to added
$init_year = '1999';
if(isset($_POST['holi_price_0']) AND $_POST['holi_price_0'] != '' AND $_POST['holi_price_0'] != '0'){
  $ptemp = $admin->get_post('holi_price_0');
  $ptmp = str_replace($num_points,$repl_points,$ptemp);
  $p = intval($ptmp);
  $p = $p / 100;
  $holi_type = $admin->get_post('holi_type_0');
  $holi_d = $admin->get_post('holi_day_d_0');
  $holi_m = $admin->get_post('holi_day_m_0');
  $holi_day = gmdate('z',mktime(12,0,0,$holi_m,$holi_d,$init_year))+1;
  $query = "INSERT INTO `".TABLE_PREFIX."res_price_holi` "
		 ."(`object_id`,`section_id`,`holi_day`,`holi_type`,`holi_price`,`vat`) VALUES "
		 ."('$object_id','$section_id','$holi_day','$holi_type','$p','$def_vat')";

  $datapdo->query($query);

  $last_holi_id = $datapdo->get_one("SELECT LAST_INSERT_ID()");
}

// Now get all holidays and update them
$get_old_holi = $datapdo->query("SELECT `rpholi_id`,`holi_day` FROM `".TABLE_PREFIX."res_price_holi` WHERE `section_id`='$section_id' AND `rpholi_id`!='$last_holi_id'");
while($old_holi = $datapdo->fetchRow($get_old_holi)){
  $rphid = $old_holi['rpholi_id'];
  $ptemp = $admin->get_post('holi_price_'.$rphid);
  $ptmp = str_replace($num_points,$repl_points,$ptemp);
  $p = intval($ptmp);
  $p = $p / 100;
  if(isset($_POST['holi_day_d_'.$rphid])){
    $holi_d = $admin->get_post('holi_day_d_'.$rphid);
    $holi_m = $admin->get_post('holi_day_m_'.$rphid);
    $holi_day = gmdate('z',mktime(12,0,0,$holi_m,$holi_d,$init_year))+1;
  }
  else{
    $holi_day = $old_holi['holi_day'];
  }
  $holi_type = $admin->get_post('holi_type_'.$rphid);

  $query = "UPDATE `".TABLE_PREFIX."res_price_holi` SET "
		 ."`holi_day`='$holi_day', "
		 ."`holi_type`='$holi_type', "
		 ."`holi_price`='$p',"
		 ."`vat`='$def_vat' "
		 ." WHERE `rpholi_id`='$rphid' LIMIT 1";

  $datapdo->query($query);
  if($datapdo->is_error()) {
    $is_error = true;
    $error_message .= (!empty($error_message)?'<br />':'').$datapdo->get_error();
  }
}

// Check we have an new add price
if(isset($_POST['adds_price_0']) AND $_POST['adds_price_0']!=''){
  $ptemp = $admin->get_post('adds_price_0');
  $adds_pricetmp = str_replace($num_points,$repl_points,$ptemp);
  $adds_price = intval($adds_pricetmp);
  $adds_price = $adds_price / 100;
  $adds_type = $admin->get_post('adds_type_0');
  $adds_vat = $admin->get_post('adds_vat_0');
  $adds_external = (isset($_POST['external_0'])?'1':'0');
  $def_adds_name = $admin->get_post('adds_type_0_'.$def_lang);
  $adds_start = $admin->get_post('addsstart_0');
  $addsstart = ($adds_start!=''?$admin->check_res_date($adds_start):0);
  if($addsstart > 0){ $addsstart = $addsstart - (14 * 3600) + 1; }
  $adds_end = $admin->get_post('addsend_0');
  $addsend = ($adds_end!=''?$admin->check_res_date($adds_end):0);
  if($adds_type < 3){
    $addsstart = 0;
    $addsend = 0;
  }
  if($addsend > 0){ $addsend = $addsend + (10 * 3600) - 1; }
  if($addsend < $addsstart OR ($addsend > 0 AND $addsstart == 0)){
    $error_message .= (!empty($error_message)?'<br />':'').$TEXT['ERROR'].': '.$CALTEXT['PRICES_ADDS'].' - '.$CALTEXT['ADDS_DATE'];
  }
  if(empty($def_adds_name)){
    $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_ADDSLABEL_ERROR'];
  }
  $adds_name_array = array();
  foreach($all_lang_array AS $lKey){
    if(isset($_POST['adds_name_0_'.$lKey]) AND $_POST['adds_name_0_'.$lKey]!=''){
      $addsname = umlauts_to_entities($admin->get_post('adds_name_0_'.$lKey));
    }
    else{
      $addsname = $def_adds_name;
    }
    $adds_name_array[$lKey]=$addsname;
  }
  $adds_name = serialize($adds_name_array);
  $datapdo->query("INSERT INTO `".TABLE_PREFIX."res_price_adds` "
		 ."(`object_id`,`section_id`,`adds_type`,`external`,`adds_name`,`adds_price`,`vat`,`addsstart`,`addsend`) VALUES "
		 ."('$object_id','$section_id','$adds_type','$adds_external','$adds_name','$adds_price','$adds_vat','$addsstart','$addsend')");
  $last_adds_id = $datapdo->get_one("SELECT LAST_INSERT_ID()");
}

// Update the old adds prices
$get_adds_price = $datapdo->query("SELECT `rpadds_id`,`isold` FROM `".TABLE_PREFIX."res_price_adds` WHERE `section_id`='$section_id' AND `rpadds_id`!='$last_adds_id'");
if($datapdo->numRows($get_adds_price)>0){
  while($old_padds = $datapdo->fetchRow($get_adds_price)){
    $rpadds_id = $old_padds['rpadds_id'];
    $isold = $old_padds['isold'];
    $ptemp = $admin->get_post('adds_price_'.$rpadds_id);
    $adds_pricetmp = str_replace($num_points,$repl_points,$ptemp);
    $adds_price = intval($adds_pricetmp);
    $adds_price = $adds_price / 100;
    $adds_vat = $admin->get_post('adds_vat_'.$rpadds_id);
    $adds_type = $admin->get_post('adds_type_'.$rpadds_id);
    $adds_external = (isset($_POST['external_'.$rpadds_id])?'1':'0');
    $adds_extp = $admin->get_post('adds_extp_'.$rpadds_id);
    $adds_alldays = $admin->get_post('adds_alldays_'.$rpadds_id);
    $adds_start = $admin->get_post('addsstart_'.$rpadds_id);
    $addsstart = ($adds_start!=''?$admin->check_res_date($adds_start):0);
    if($addsstart > 0){ $addsstart = $addsstart - (14 * 3600) + 1; }
    $adds_end = $admin->get_post('addsend_'.$rpadds_id);
    $addsend = ($adds_end!=''?$admin->check_res_date($adds_end):0);
    if($adds_type < 3){
      $addsstart = 0;
      $addsend = 0;
    }
    if($addsend > 0){ $addsend = $addsend + (10 * 3600) - 1; }
    if($addsend < $addsstart OR ($addsend > 0 AND $addsstart == 0 AND $isold == 0)){
      $error_message .= (!empty($error_message)?'<br />':'').$TEXT['ERROR'].': '.$CALTEXT['PRICES_ADDS'].' - '.$CALTEXT['ADDS_DATE'];
    }
    $def_adds_name = umlauts_to_entities($admin->get_post('adds_name_'.$rpadds_id.'_'.$def_lang));
    if(empty($def_adds_name) AND $isold == 0){
      $error_message .= (!empty($error_message)?'<br />':'').$CALTEXT['SEASON_ADDSLABEL_ERROR'];
    }
    $adds_name_array = array();
    foreach($all_lang_array AS $lKey){
      if(isset($_POST['adds_name_'.$rpadds_id.'_'.$lKey]) AND $_POST['adds_name_'.$rpadds_id.'_'.$lKey]!=''){
        $addsname = umlauts_to_entities($admin->get_post('adds_name_'.$rpadds_id.'_'.$lKey));
      }
      else{
        $addsname = $def_adds_name;
      }
      $adds_name_array[$lKey]=$addsname;
    }
    $adds_name = serialize($adds_name_array);
    $query = "UPDATE `".TABLE_PREFIX."res_price_adds` SET "
		   ."`adds_price`='$adds_price', "
		   ."`vat`='$adds_vat', "
		   ."`adds_name`='$adds_name', "
		   ."`adds_type`='$adds_type', "
		   ."`external`='$adds_external', "
		   ."`only_ext_persons`='$adds_extp', "
		   ."`adds_alldays`='$adds_alldays', "
		   ."`addsstart`='$addsstart', "
		   ."`addsend`='$addsend' "
		   ." WHERE `rpadds_id`='$rpadds_id' LIMIT 1";
    $datapdo->query($query);
    if($datapdo->is_error()){
      $is_error = true;
      $error_message .= (!empty($error_message)?'<br />':'').$datapdo->get_error();
    }
  }
}
// Update the additional prices for MORE field id availabel
$get_more_price = $datapdo->query("SELECT `rpmore_id` FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$section_id'");
if($datapdo->numRows($get_more_price)>0){
  while($old_pmore = $datapdo->fetchRow($get_more_price)){
    $rpmore_id = $old_pmore['rpmore_id'];
    if(!isset($_POST['more_price_'.$rpmore_id])){
       // Delete a non price field
       $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_more` WHERE `rpmore_id`='$rpmore_id' LIMIT 1");
       continue 1;
    }
    $ptemp = $admin->get_post('more_price_'.$rpmore_id);
    $more_price_tmp = str_replace($num_points,$repl_points,$ptemp);
    $more_price_int = intval($more_price_tmp);
    $more_price = $more_price_int / 100;
    $more_vat = $admin->get_post('more_vat_'.$rpmore_id);
    $more_type = $admin->get_post('more_type_'.$rpmore_id);
    $more_alldays = $admin->get_post('more_alldays_'.$rpmore_id);
    $query = "UPDATE `".TABLE_PREFIX."res_price_more` SET "
		   ."`more_price`='$more_price', "
		   ."`vat`='$more_vat', "
		   ."`more_type`='$more_type', "
		   ."`more_alldays`='$more_alldays' "
		   ." WHERE `rpmore_id`='$rpmore_id' LIMIT 1";
    $datapdo->query($query);
    if($datapdo->is_error()){
      $is_error = true;
      $error_message .= (!empty($error_message)?'<br />':'').$datapdo->get_error();
    }
  }
}
// Check if there is a db error, otherwise say successful
if($is_error == true){
  if(count($uquery)>0){
    $_SESSION['uquery']=$uquery;
    echo '<center>'.$error_message.'<br />';
    echo '<input type="button" value="'.$CALTEXT['SEASON_NO_CORRECT'].'" onclick="autocorrektor(false);" style="width:30%" />'."\n";
    echo '<input type="button" value="'.$CALTEXT['SEASON_AUTO_CORRECT'].'" onclick="autocorrektor(true);" style="width:30%" />'."\n";
    echo '</center>'."\n";
    echo '<script type="text/javascript">'."\n";
    echo 'function autocorrektor(bol){'."\n";
    echo '  if(bol==true){'."\n";
    echo '    var autourl = "'.BC_URL.'/modules/calendar/autoupdate_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.ARGSOJS.'autoupdate=1";';
    echo '    $("#noBox").load(autourl);'."\n";
    echo '  }'."\n";
    echo '  else{'."\n";
    echo '    var autourl = "'.BC_URL.'/modules/calendar/autoupdate_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.'";';
    echo '    $("#noBox").load(autourl);'."\n";
    echo '  }'."\n";
    echo '  location.href="'.BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.$backobj.'";'."\n";
    echo '}'."\n";
    echo '</script>'."\n";
  }
  else{
    $admin->print_error($error_message.($is_export==true?$CALTEXT['PRICE_NOEXPORT']:''), BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSO.'section_id='.$section_id.$backobj);
  }
}
else {
  // Export all prices to other object if it is available
  if($is_export==true){
    foreach($price_export AS $eKey => $eObj){
      $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$eObj'");
    }
    // Get the form object of source object
    $source_form = $datapdo->get_one("SELECT `form_object` FROM `".TABLE_PREFIX."calendar` WHERE `section_id`='$section_id' LIMIT 1");
    $source_form = ($source_form > 0?$source_form:$object_id);
    // Get the current settings
    $get_sets = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_sets` WHERE `section_id`='$section_id' LIMIT 1");
    $sets = $datapdo->fetchRow($get_sets);
    $price_type = $sets['price_type'];
    $price_seas = $sets['price_seas'];
    $seas_modus = $sets['seas_modus'];
    $staggering = $sets['staggering'];
    $p_stagg1 = $sets['p_stagg1'];
    $p_stagg2 = $sets['p_stagg2'];
    $p_stagg3 = $sets['p_stagg3'];
    $p_stagg4 = $sets['p_stagg4'];
    $p_unit = $sets['p_unit'];
    $preprice = $sets['preprice'];
    $show_prices = $sets['show_prices'];
    $roundprice = $sets['roundprice'];
    foreach($price_export AS $eKey => $eObj){
      $error_adds .= '<br />'.$MESSAGE['SIGNUP']['ERROR'].$CALTEXT['ADDS_INFO'].' '.$TEXT['FOR'].' '.$TEXT['OBJECT'].' '.$admin->zero_to_number($eObj);
      // Check first the calculator is active
      $get_eCal = $datapdo->query("SELECT `section_id`,`calculator` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$eObj' LIMIT 1");
      $eCal = $datapdo->fetchRow($get_eCal);
      $esec = $eCal['section_id'];
      if($eCal['calculator'] != 1){
        $datapdo->query("UPDATE `".TABLE_PREFIX."calendar` SET `calculator`='1' WHERE `section_id`='$esec' LIMIT 1");
      }
      // Check the section has prices
      $get_eObj_pricesets = $datapdo->query("SELECT `rpsets_id` FROM `".TABLE_PREFIX."res_price_sets` WHERE `object_id`='$eObj' LIMIT 0,1");
      if($datapdo->numRows($get_eObj_pricesets) > 0){
        $query = "UPDATE `".TABLE_PREFIX."res_price_sets` SET "
		      ."`price_type`='$price_type', "
		      ."`price_seas`='$price_seas', "
		      ."`seas_modus`='$seas_modus', "
		      ."`staggering`='$staggering', "
		      ."`p_stagg1`='$p_stagg1', "
		      ."`p_stagg2`='$p_stagg2', "
		      ."`p_stagg3`='$p_stagg3', "
		      ."`p_stagg4`='$p_stagg4', "
		      ."`p_unit`='$p_unit', "
		      ."`preprice`='$preprice', "
		      ."`show_prices`='$show_prices', "
		      ."`roundprice`='$roundprice' "
		      ."WHERE `object_id`='$eObj' LIMIT 1";
      }
      else{
        $query = "INSERT INTO `".TABLE_PREFIX."res_price_sets` "
		      ."(`object_id`,`section_id`,`price_type`,`price_seas`,`seas_modus`,`staggering`,`p_stagg1`,`p_stagg2`,`p_stagg3`,`p_stagg4`,`p_unit`,`preprice`,`show_prices`,`roundprice`) VALUES "
		      ."('$eObj','$esec','$price_type','$price_seas','$seas_modus','$staggering','$p_stagg1','$p_stagg2','$p_stagg3','$p_stagg4','$p_unit','$preprice','$show_prices','$roundprice')";
      }
      $datapdo->query($query);
      // Insert current discounts into this object
      $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_discounts` WHERE `object_id`='$eObj'");
      $get_disc = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_discounts` WHERE `section_id`='$section_id'");
      while($disc = $datapdo->fetchRow($get_disc)){
        $discount_type = $disc['discount_type'];
        $lastminute_days = $disc['lastminute_days'];
        $percent = $disc['percent'];
        $datapdo->query("INSERT INTO `".TABLE_PREFIX."res_discounts` (`object_id`,`section_id`,`discount_type`,`lastminute_days`,`percent`) VALUES ('$eObj','$esec','$discount_type','$lastminute_days','$percent')");
      }
      // Insert current seasons into this object
      $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_seas` WHERE `object_id`='$eObj'");
      $get_seas = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_seas` WHERE `section_id`='$section_id'");
      if($datapdo->numRows($get_seas)>0){
        while($seas = $datapdo->fetchRow($get_seas)){
          $season_start = $seas['season_start'];
          $season_end = $seas['season_end'];
          $season_year = $seas['season_year'];
          $season_name = $seas['season_name'];
          $arrivaldays = $seas['arrivaldays'];
          $min_resdays = $seas['min_resdays'];
          $p0 = $seas['p0'];
          $p1 = $seas['p1'];
          $p2 = $seas['p2'];
          $p3 = $seas['p3'];
          $p4 = $seas['p4'];
          $vat = $seas['vat'];
          $insert = "INSERT INTO `".TABLE_PREFIX."res_price_seas` "
		   ."(`object_id`,`section_id`,`season_start`,`season_end`,`season_year`,`season_name`,`arrivaldays`,`min_resdays`,`p0`,`p1`,`p2`,`p3`,`p4`,`vat`) VALUES "
		   ."('$eObj','$esec','$season_start','$season_end','$season_year','$season_name','$arrivaldays','$min_resdays','$p0','$p1','$p2','$p3','$p4','$vat')";
          $datapdo->query($insert);
        }
      }

      // Check first the old prices are in invoice then set to old or delete unused prices
      $get_allold = $datapdo->query("SELECT `rpadds_id` FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$eObj' AND `isold`='0'");
      if($datapdo->numRows($get_allold)>0){
        while($allold = $datapdo->fetchRow($get_allold)){
          if($datapdo->numRows($datapdo->query("SELECT `invoice_id` FROM `".TABLE_PREFIX."res_invoice` WHERE `object_id`='$eObj' AND `item_id`='ADDS_".$allold['rpadds_id']."' LIMIT 0,1"))>0){
            $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_adds` SET `isold`='1' WHERE `object_id`='$eObj' AND `rpadds_id`='".$allold['rpadds_id']."'");
          }
          else{
            $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_adds` WHERE `object_id`='$eObj' AND `rpadds_id`='".$allold['rpadds_id']."' LIMIT 1");
          }
        }
      }
      // Set first all old prices to old
      $get_adds = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_adds` WHERE `section_id`='$section_id' AND `isold`='0'");
      if($datapdo->numRows($get_adds)>0){
        while($adds = $datapdo->fetchRow($get_adds)){
          $adds_type = $adds['adds_type'];
          $only_ext_persons = $adds['only_ext_persons'];
          $adds_name = $adds['adds_name'];
          $check_namearr = unserialize($adds_name);
          $check_name = $check_namearr[DEFAULT_LANGUAGE];
          $adds_price = $adds['adds_price'];
          $adds_alldays = $adds['adds_alldays'];
          $adds_external = $adds['external'];
          $adds_start = $adds['addsstart'];
          $adds_end = $adds['addsend'];
          $vat = $adds['vat'];
          // If new add insert new item
          $insert = "INSERT INTO `".TABLE_PREFIX."res_price_adds` "
		   ."(`object_id`,`section_id`,`adds_type`,`only_ext_persons`,`adds_name`,`adds_price`,`vat`,`adds_alldays`,`external`,`addsstart`,`addsend`) VALUES "
		   ."('$eObj','$esec','$adds_type','$only_ext_persons','$adds_name','$adds_price','$vat','$adds_alldays','$adds_external','$adds_start','$adds_end')";
          $datapdo->query($insert);
        }
        // Update all old with current date
        $change_date = time();
        $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_adds` SET `addsend`='$change_date' WHERE `object_id`='$eObj' AND `isold`='1' AND (`addsend`>'$change_date' OR `addsend`='0')");
        $must_disable_specials = true;
      }
      // Get the form for the new object
      $get_pmore_form = $datapdo->get_one("SELECT `form_object` FROM `".TABLE_PREFIX."calendar` WHERE `object_id`='$eObj' LIMIT 1");
      $form_obj = ($get_pmore_form > 0?$get_pmore_form:$eObj);
      // Set first all old prices to old
      $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_more` SET `isold`='1' WHERE `object_id`='$eObj'");
      // Get the form fields of current object

      // Insert current more into this object
      $get_more = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_more` WHERE `section_id`='$section_id' Order BY `more_id`");
      $new_more = $datapdo->numRows($get_more);
      if($new_more>0){
        while($more = $datapdo->fetchRow($get_more)){
          $more_name = get_name_addkey($more['rpmore_id'],'more',$section_id);
          $more_type = $more['more_type'];
          $more_key = $more['more_key'];
          $more_id = $more['more_id'];
          $more_price = $more['more_price'];
          $more_alldays = $more['more_alldays'];
          $vat = $more['vat'];
          $rpmore_id = 0;
	 $isset = false;
          if($form_obj == $source_form){
            $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_more` SET"
			   ."`more_type`='$more_type',`more_price`='$more_price',`more_alldays`='$more_alldays',`vat`='$vat',`isold`='0'"
			   ." WHERE `object_id`='$eObj' AND `more_key`='$more_key' AND `more_id`='$more_id' LIMIT 1");
            $isset = true;
          }
          else{
            // Second check the name
            $get_name_formobj = $datapdo->query("SELECT `field_id` FROM `".TABLE_PREFIX."forms` WHERE `object_id`='$form_obj' AND (`field_name`='MORE' OR `forprices`='1')");
            if($datapdo->numRows($get_name_formobj)>0){
              while($fields = $datapdo->fetchRow($get_name_formobj)){
                $fld_id = $fields['field_id'];
                $extras = $datapdo->get_one("SELECT `field_extra` FROM `".TABLE_PREFIX."form_labels` WHERE `field_id`='$fld_id' AND `language`='".DEFAULT_LANGUAGE."' LIMIT 1");
                $foundnames = explode('|',$extras);
                if($key = array_search($more_name,$foundnames)){
                  // Get the price table this more and update if exists
                  $get_rpmore = $datapdo->query("SELECT `rpmore_id` FROM `".TABLE_PREFIX."res_price_more` WHERE `object_id`='$eObj' AND `more_key`='$fld_id' AND `more_id`='$key' LIMIT 0,1");
                  if($datapdo->numRows($get_rpmore)>0){
                    $oldmore = $datapdo->fetchRow($get_rpmore);
                    $rpmore_id = $oldmore['rpmore_id'];
                  }
                }
              }
            }
          }
          if($rpmore_id > 0){
            // We must update the old more price
            $datapdo->query("UPDATE `".TABLE_PREFIX."res_price_more` SET "
			   ."`more_type`='$more_type',`more_price`='$more_price',`vat`='$vat',`more_alldays`='$more_alldays',`isold`='0'"
			   ." WHERE `rpmore_id`='$rpmore_id' LIMIT 1");
            $isset = true;
          }
        }
        // Update all old with current date
        if($isset == false){
          $error_message .= ($error_message!=''?'<br />':'').$TEXT['ERROR'].' '.$TEXT['OBJECT'].': '.$admin->zero_to_number($eObj);
        }
        else{ $must_disable_specials = true; }
      }
      // Insert current holi into this object
      $datapdo->query("DELETE FROM `".TABLE_PREFIX."res_price_holi` WHERE `object_id`='$eObj'");
      $get_holi = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."res_price_holi` WHERE `section_id`='$section_id'");
      while($holi = $datapdo->fetchRow($get_holi)){
        $holi_day = $holi['holi_day'];
        $holi_type = $holi['holi_type'];
        $holi_price = $holi['holi_price'];
        $vat = $holi['vat'];
        $insert = "INSERT INTO `".TABLE_PREFIX."res_price_holi` "
		   ."(`object_id`,`section_id`,`holi_day`,`holi_type`,`holi_price`,`vat`) VALUES "
		   ."('$eObj','$esec','$holi_day','$holi_type','$holi_price','$vat')";
        $datapdo->query($insert);
      }
    }
  }
  if(isset($_POST['paycontrol'])){
    $paycontrol = $admin->get_post_escaped('paycontrol');
    include(ADMIN_PATH.'/reservations/save_paymentset.php');
  }
  if($error_message==''){
    if($must_disable_specials == true){
      // Disable the all specials this object
      $have_special = $datapdo->numRows($datapdo->query("SELECT `lmitem_id` FROM `".TABLE_PREFIX."res_special` WHERE `ref_object`='$object_id'"));
      if($have_special > 0){
        if(!file_exists(BC_PATH .'/modules/special_offer/languages/'.LANGUAGE .'.php')) {
          // no module language file exists for the language set by the user, include default module language file EN.php
          require(BC_PATH .'/modules/special_offer/languages/EN.php');
        }
        else {
          // a module language file exists for the language defined by the user, load it
          require(BC_PATH .'/modules/special_offer/languages/'.LANGUAGE .'.php');
        }
        if(file_exists(BC_PATH .'/modules/special_offer/languages/user_'.LANGUAGE .'.php')) {
          require(BC_PATH .'/modules/special_offer/languages/user_'.LANGUAGE .'.php');
        }
        $datapdo->query("UPDATE `".TABLE_PREFIX."res_special` SET `active`='0' WHERE `ref_object`='$object_id'");
        $admin->print_error($TEXT['SUCCESS'].'<br />'.$MESSAGE['SIGNUP']['ERROR'].$SPOTEXT['SPECIAL_OFFER'].$error_adds.'!', BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.$backobj);
      }
      else{
        $admin->print_success($TEXT['SUCCESS'].$error_adds, BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.$backobjjs);
      }
    }
    else{
      $admin->print_success($TEXT['SUCCESS'].$error_adds, BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.$backobjjs);
    }
  }
  else{
    $admin->print_error($error_message, BC_URL.'/modules/calendar/mod_prices.php?object_id='.$object_id.ARGSOJS.'section_id='.$section_id.$backobj);
  }
}

// Print admin footer
$admin->print_footer();